#include "RIPCTest.h"


/**
 * Test for events with automatic reset.
 * Usage:
 * Start N processes with IDs 0,1,..N-1:
 *    java Baton 3 0
 *    java Baton 3 1
 *    Baton 3 2
 * Output: none
 */
class Baton : public RIPCTest { 
  public:
    void run(RIPCSession* session, int id) { 
	int nParticipants = nProcesses;
	int i;
	RIPCEvent** event = new RIPCEvent*[nParticipants];
	for (i = 0; i < nParticipants; i++) { 
	    char name[256];
	    sprintf(name, "event%d", i); 
	    event[i] = session->createEvent(name, i == 0, false);
	}
	for (i = 0; i < nIterations; i++) { 
	    event[id]->waitFor();
	    event[(id+1) % nParticipants]->signal();
	}
    }
};

int main(int argc, char* argv[]) { 
    Baton test;
    return test.main(argc ,argv);
}

